package com.liang.service;

import com.liang.entity.BaseProjectbudget;
import com.liang.entity.PrjBudget;
import com.liang.entity.PrjBudgetRecord;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;

/**
 * 项目预算(PrjBudget)表服务接口
 *
 * @author makejava
 * @since 2023-03-10 07:49:56
 */
public interface PrjBudgetService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjBudget queryById(Integer id);

    /**
     * 分页查询
     *
     * @param prjBudget   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<PrjBudget> queryByPage(PrjBudget prjBudget, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjBudget 实例对象
     * @return 实例对象
     */
    PrjBudget insert(PrjBudget prjBudget);

    /**
     * 修改数据
     *
     * @param prjBudget 实例对象
     * @return 实例对象
     */
    int update(PrjBudget prjBudget);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 根据项目删除数据
     *
     * @param xm
     * @return
     */
    boolean deleteByXm(Integer xm);

    /**
     * 获取预算列表
     *
     * @return
     */
    List<PrjBudget> getBudgetList(Integer xm);

    /**
     * 根据项目类型（项目模板）插入
     *
     * @param xmlx
     * @return
     */
    int insertBatchByXmlx(String xmlx, Integer xm);

    /**
     * 更新预算
     *
     * @param prjBudgets
     * @return
     */
    int updateBatch(List<PrjBudget> prjBudgets);

    /**
     * 完成单位数量
     *
     * @param count
     * @return
     */
    int updateYsByXm(Integer xm, Integer count);

    List<PrjBudget> getXGJL(int xmid);

    int updateXg(List<PrjBudgetRecord> prjBudgetRecordList);

    List<PrjBudget> getOldBudgetList(Integer id);
}
